#include <stdio.h>
#include <sys/sysctl.h>
#include <errno.h>
#include <stdlib.h>
#include <limits.h>
#include "shadowmac.h"
extern int errno;

int set_shadowmac_status(int status)
{
	char *name="net.link.ether.inet.jc_shadowmac_status";
	int  retval;
	size_t len= sizeof(status);

	retval=sysctlbyname(name, NULL, 0, &status, len);
	if (retval == 0)
		return 1;
	else //error
		return 0;
}
int get_shadowmac_status()
{
	char *name="net.link.ether.inet.jc_shadowmac_status";
	int status, retval;
	size_t len= sizeof(status);
	retval=sysctlbyname(name, &status, &len, NULL, 0);
	if (retval != 0)
		return -1; // error reading.
	else
		return status;

}
int set_shadowmac_log_status(int status)
{
	char *name="net.link.ether.inet.jc_shadowmac_log_status";
	int  retval;
	size_t len= sizeof(status);

	retval=sysctlbyname(name, NULL, 0, &status, len);
	if (retval == 0)
		return 1;
	else //error
		return 0;
}
int get_shadowmac_log_status()
{
	char *name="net.link.ether.inet.jc_shadowmac_log_status";
	int status, retval;
	size_t len= sizeof(status);
	retval=sysctlbyname(name, &status, &len, NULL, 0);
	if (retval != 0)
		return -1; // error reading.
	else
		return status;

}

int get_shadow_table(struct jc_shadowmac_data *shadowmac_data)
{
	char *name="net.link.ether.inet.jc_shadowmac_data";
	int bufsize, retval;
	size_t len;
	len=sizeof(*shadowmac_data);
	retval=sysctlbyname(name, shadowmac_data, &len, NULL, 0);

	if (retval == 0)
		return 1;
	else
		return 0;
}


/* set table in kernel, return 1 on sucess, 0 otherwise */
int set_shadow_table(struct jc_shadowmac_data *shadowmac_data)

{
	char *name="net.link.ether.inet.jc_shadowmac_data";
	int bufsize, retval;
	size_t len;
	len=sizeof(*shadowmac_data);

	retval=sysctlbyname(name, NULL, 0, shadowmac_data, len);
	if (retval == 0)
		return 1;
	else
		return 0;
}

void print_shadow_table(struct jc_shadowmac_data *shadowmac_data)
{
    printf("[%x:%x:%x:%x:%x:%x]->",
		shadowmac_data->mac[0], shadowmac_data->mac[1], shadowmac_data->mac[2], 
			shadowmac_data->mac[3], shadowmac_data->mac[4], shadowmac_data->mac[5]);
                
    printf("[%x:%x:%x:%x:%x:%x]\n",
    shadowmac_data->shadow_mac[0], shadowmac_data->shadow_mac[1], shadowmac_data->shadow_mac[2], 
    shadowmac_data->shadow_mac[3], shadowmac_data->shadow_mac[4], shadowmac_data->shadow_mac[5]);
}

/*
 * this is one of those functions you hate to run across in C
 *  It takes a string reprenting a mac address, like 00:11:22:33,
 *  and converts it into a real mac address in memory. 
 *  it only accepts strings with 6 bytes.
 */

int  parse_address(char *string_addr, u_char addr[6])
{
	char *p1, *p2;
	char tmp[3];
	p1 = string_addr;
	p2 = string_addr;
	int len = strlen(string_addr);
	int i;
	long octet; // not really an octect, but i need a name for it.
	char c;
	int byte_counter = 0;

	if (len > 30)
		return 0;
	for (i = 0; i <= len; i++)
	{
		if ( (*p2 == ':') || (i == len)) // i==len is last octet, not terminated by :
		{
			if (p2 - p1 > 2)
			{
				//printf("Cant parse %s\n", string_addr);
				//printf("p2 -p1 = %d\n", p2 - p1);
				return 0;
			}
			memcpy(tmp, p1, p2 - p1);
			tmp[p2 - p1] = NULL;
		//	printf("tmp is %s\n", tmp);
			p1 = p2 + 1; /* skip : */
			
			octet = strtol(tmp, NULL, 16);
			//printf("octet = %x\n", octet);
			if (octet == 0 && errno == EINVAL)
				return 0;

			c = (char) octet;
			addr[byte_counter] = c;
			if (byte_counter > 5)
				return 0;
			byte_counter++;
			
		}

		p2 +=1;
	}	
	/* no short addresses accepted */
	if (byte_counter == 6)	
		return 1;
	else
		return 0;
		
}


